/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                  
******************************************************************************/

#ifndef ADC_H__
#define ADC_H__

#include "user.h"

#define     CH0      0x00
#define     CH1      0x10
#define     CH2      0x20
#define     CH3      0x30
#define     CH4      0x40
#define     CH5      0x50
#define     CH6      0x60
#define     CH7      0x70
#define     CH8      0x80
#define     CH9      0x90
#define     CH13     0xD0
#define     CH14     0xE0
#define     CH15     0xF0

char ADC_ZERO(void);
void ADC_Init(void);
void ADC_ADCHS(uint8_t CH);
uint16_t ADC_Get_Value(uint8_t CH);
uint16_t ADC_Get_FlagStatus();

#endif
