/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   FLASH
;  *            ļҳ
;  *                     ֽд
;  *                     ֽڶȡ
******************************************************************************/

#include "FLASH.h"

/************************************************
;  *    @            : FLASH_PAGE_Erase
;  *    @˵              : FLASHҳ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void FLASH_PAGE_Erase(uint16_t addr)
{
    DISABLE_GIE();
    CLR_INFOS();             //лFLASH
    CLR_BLRS();
    SET_MFREN();
    SET_IAPEN();
    SET_IAPEN();             //IAP(дЧ)
    SET_CLRPL();
    SET_CLRPL();
    addr = addr <<6;
    IAPADL = addr;           //Ǹҳ׵ַ
    IAPADH = addr>>8;
    IAPDBH = 0;
    SET_IAPEN();
    SET_IAPEN();
    SET_PAGEERS(); 
    SET_PAGEERS();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPSTR() ;
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG0();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG1();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG2();
    while (IAPCR & 0x80);
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
}

/************************************************
;  *    @            : FLASH_Byte_Write
;  *    @˵              : FLASHдģʽ
;  *    @          : addrַ 00xFFFF,value 
;  *    @ز          :
;  ***********************************************/
void FLASH_Byte_Write(uint16_t addr,uint16_t value)
{
    DISABLE_GIE();
    CLR_INFOS();             //лFLASH
    CLR_BLRS();
    SET_MFREN();
    SET_IAPEN();
    SET_IAPEN();             //IAP(дЧ)
    SET_CLRPL();
    SET_CLRPL(); 
    IAPADL = addr;
    IAPADH = addr>>8;
    IAPDBL = value;
    IAPDBH = value>>8;
    SET_IAPEN();
    SET_IAPEN();
    SET_PROWR();
    SET_PROWR();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPSTR();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG0();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG1();
    IAPKEY = 0x5A;
    IAPKEY = 0xA5;
    SET_IAPTRIG2();
    while (IAPCR & 0x80);
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
}

/************************************************
;  *    @            : FLASH_Byte_Read
;  *    @˵              : FLASHֽڶ
;  *    @          : addrַ 00xFFFF
;  *    @ز          :
;  ***********************************************/
uint16_t FLASH_Byte_Read(uint16_t addr)
{
    uint16_t Value;
    DISABLE_GIE();
    CLR_INFOS();             //лFLASH
    CLR_BLRS();
    Value= *(uint16_t code *)addr;
    CLR_INFOS();             //лFLASH
    ENABLE_GIE();
    return Value;
}

