/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                T3ʱʽ0 ϵͳƵʱ1ms
;  *                       ʽ1 ϵͳƵ32Kʱ2ms
******************************************************************************/

#include "TIMER.h"

/************************************************
;  *    @            : Timer3_Init
;  *    @˵              : T3,32k,Ƶʱ10ms
;  *                         65535 - 320 = 0xFEBF
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Timer3_Init(void)
{
    T3CR |= DEF_SET_BIT3;         //T3ģ
    T3CR &=~ DEF_SET_BIT6;        //ʱԴΪFsys
    T3CR &= 0xf8;                 //1Ƶ 

    T3CR &=~ DEF_SET_BIT7;        //رT3
    TL3 = 0xBF;
    TH3 = 0xFE;
    T3CR |= DEF_SET_BIT7;         //T3

    IEN1 |= DEF_SET_BIT1;          //ʹж
}

void Timer3_ISR(void) interrupt T3_IRQn
{
    T3CR &= DEF_CLR_BIT5;
    LED1 = !LED1;
}
