/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                IIC_Slave
;  *           MCU 16MHz
;  *           ͨţдݺ
;  *           Կʹ[DIO1(P15),CLK1(P16)]
;  *           IIC_SCL:P11D,IIC_SDA:P12D.
******************************************************************************/

#include "user.h"
#include "intrins.h"

__O Flag flag1;

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    uint16_t test_result =0 ;
    DISABLE_GIE();           //disable interrupt
    OSCSS &= ~0x70;
    GPIO_Init();
    IIC_Init();
    ENABLE_GIE();            //enable interrupt
    while (1)
    {
        if(IICSR & 0x10)
        {
            if(iic_status == IIC_STS_RX)
            {
                iic_tx_idx = 0;
                iic_status = IIC_STS_TX;
            }
            F_ADDR_SAME = 0;
        }
    }
}