/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *          
******************************************************************************/

#ifndef SPI_H__
#define SPI_H__

#include "user.h"

#define  CS       P21D

void SPI_Init(void);
uint8_t SPI1_ReadWriteByte(uint8_t TxData);

// <<< Use Configuration Wizard in Context Menu >>>\n
// <h> SPI_Master_Slave
// <o>SPI_Master_Slave
// <i>  This is modes, 0 is Master, 1 is Slave
// <0=>  master
// <1=>  slave

#define SPI_Master_Slave    0
// </h>
// <<< end of configuration section >>>

#endif



