/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                 SPI  дW25QXX(3.3V)
;  *            дݣ(baud 9600)
;  *                      UART0:TX0-P23D ;RX0-P22D
;  *                      SPI:NSS-P21D ;SCK-P26D
;  *                          MISO-P10D ; MOSI-P27D
******************************************************************************/

#include "user.h"

#define TEST_FLASH_ADDR    0
//ȫֱ
__O Flag flag1;
//˽б

u8 code TEXT_Buffer[] = {0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A};    //д

/************************************************
;  *    @            : delay
;  *    @˵              : ʱʾʹãʵʱ
;  *    @          : Num
;  *    @ز          :
;  ***********************************************/
void delay(uint16_t Num)
{
    for (; Num > 0; Num--)
    {
        NOP1();
    }
}

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main(void)
{
    uint8_t datatemp[sizeof(TEXT_Buffer)];
    u8 count = 0;
    DISABLE_GIE();           //رж
    OSCSS  &= ~0x70;
    GPIO_Init();
    UART0_Init();
    delay(100);
    printf("Sinomcu\r\n");
    W25QXX_Init();
    while (W25QXX_ReadID() != W25Q128);      //ȡоƬID
    ENABLE_GIE();            //ж
    while (1)
    {
        W25QXX_Erase_Sector(TEST_FLASH_ADDR);   
        W25QXX_Write_NoCheck(&TEXT_Buffer, TEST_FLASH_ADDR, sizeof(TEXT_Buffer));
        W25QXX_Read(datatemp, TEST_FLASH_ADDR, sizeof(TEXT_Buffer));
        for (count = 0; count < sizeof(TEXT_Buffer); count++)
        {
            printf("%bu", datatemp[count]);
        }
        printf("\r\n");
        delay(60000);
        delay(60000);
        delay(60000);
        delay(60000);
        delay(60000);
    }
}

