/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                Fsys = 16M
******************************************************************************/

#include "TIMER.h"
/************************************************
;  *    @            : Timer2_Init
;  *    @˵              : T2ʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void Timer2_Init(void)
{
    //ʱ1ms 
#if (TIMER_MODE == 0)             //16 λطʽʱ/ʽ
    T2CON = 0x00;
    T2CON1 |= DEF_SET_BIT0;         //T2ģ,ʽ0
    T2MOD = 0xA0;                   //Զ, Fsys/16
    TR2 = 0;
    TL2 = 0x18;
    TH2 = 0xFC;
    RCAPL2 =0x18;
    RCAPH2 =0xFC;
    IEN1 |= DEF_SET_BIT0;            //T2ж
    EA = 1;
    TR2 = 1;
#endif

#if(TIMER_MODE == 1)              //16 λ벶ʽ
    T2CON |= DEF_SET_BIT3;          //ʹ벶
    T2CON |= DEF_SET_BIT0;          //ѡʽΪ벶
  
    T2CON1|= DEF_SET_BIT2;          //ôΪش
    T2CON1&=~DEF_SET_BIT1;          //
    T2CON1|= DEF_SET_BIT0;          //T2ģ
  
    T2MOD |= DEF_SET_BIT6;          //Fsys/64
    T2MOD |= DEF_SET_BIT1;          //Ч
    IEN1 |= DEF_SET_BIT0;           //T2ж
//    EA = 1;
    TR2 = 1;         //ʼ
#endif

//#if(TIMER_MODE == 2)    //T2 ʽ2  16λʷ
//#endif

#if(TIMER_MODE == 3)         //T2 ʽ3  16λȽϷʽ

    T2CON = 0x00;
  //   T2CON1|= DEF_SET_BIT7;     //ƽת
    T2CON1|= DEF_SET_BIT6;        //Ƚģʽ
    T2CON1|= DEF_SET_BIT0;        //T2ģ
    
    T2MOD |= DEF_SET_BIT7;        //
    T2MOD |= DEF_SET_BIT5;        //Fsys/16
    T2MOD |= DEF_SET_BIT3;        //ת˿
    T2MOD |= DEF_SET_BIT2;        //ʼ͵ƽ
    TR2 = 0;
    TL2 = 0;
    TH2 = 0;
    RCAPL2 = 0xE8;
    RCAPH2 = 0x03;
    TR2 = 1;
    IEN1 |= DEF_SET_BIT0;
#endif
}

void Timer2_ISR(void) interrupt T2_IRQn
{
#if(TIMER_MODE == 0)
  if(TF2 == 1)
    {
        TF2 = 0;
        LED1 = !LED1;
    }
#endif

#if(TIMER_MODE == 1)
    if(TF2 == 1)
    {
        TF2 = 0;
        High_Overflow_Num++;
    }
  
    if(EXTF2 == 1)
    {
        if (FLAG_T2_UP == 0)
        {
            TR2 = 1;                        //ʼ
            FLAG_T2_UP = 1;                 //׽
            T2CON1 &=~ DEF_SET_BIT2;        //޸ĴΪ½ش
        }
       else                                 //׽½
        {
            TR2 = 0;                        //رնʱ
            FLAG_T2_DOWN = 1;               //׽
        }
        EXTF2 = 0;
    }
#endif

#if(TIMER_MODE == 3)
    if(TF2 == 1)
    {
        TF2 = 0;
        LED1 = !LED1;
    }
#endif
}
