/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                      T2
;  *             ģʽ0  LED1(P00)       1msת
;  *             ģʽ1  P21벶     P23 ʣ9600
;  *             ģʽ3  LED1(P00) 1msת P20˿ڱȽϷת
******************************************************************************/
#include "user.h"

__O Flag Flag1;
__O uint32_t High_Overflow_Num ;

uint16_t LOW_Level_Time ;
uint32_t High_Level_Time ;

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main()
{
    DISABLE_GIE();                     //رж
    OSCSS &=~0x70;        //1Ƶ
    GPIO_Init();
    UART0_Init();
    Timer2_Init();
    ENABLE_GIE();                      //ж
    printf("Sinomcu\r\n");
		
    while(1)
    {
#if(TIMER_MODE == 1)
        if(FLAG_T2_DOWN == 1)
        {
            FLAG_T2_DOWN = 0;
            LOW_Level_Time = RCAPL2;
            High_Level_Time = RCAPH2;
            High_Level_Time += LOW_Level_Time << 8;   //ȡ
    
            TL2 = 0;
            TH2 = 0;
            RCAPL2 = 0;
            RCAPH2 = 0;
            FLAG_T2_UP = 0;
            High_Level_Time=High_Level_Time+(High_Overflow_Num<<16);
            printf("%lu\r\n",High_Level_Time);        //ʱ:(0.66 * High_Level_Time)us
            High_Overflow_Num = 0;
            T2CON1 |= DEF_SET_BIT2;                   //Ч
        }
#endif
    }
}